{-# LANGUAGE FlexibleContexts #-}
{-# LANGUAGE NoMonomorphismRestriction #-}
module ParserLib(
  charCI,
  stringCI,
  nbsp,
) where
import Text.Parsec
import Control.Applicative ((<*>), (*>), (<*), (<$>), liftA2)
import Data.Char
import Data.List

charCI c | isAlpha c = (char (toUpper c)) <|> (char (toLower c))
charCI c | otherwise = char c

stringCI s = foldr (liftA2 (:)) (return []) (charCI <$> s)

tryStringCI = try . stringCI

nbsp = satisfy (\c -> (c /= '\n') && (c /= '\r') && (isSpace c)) <?> "space"

