module SqrFile (matchFileName, searchFile) where
import Text.Parsec
import ParserLib
import System.Directory
import System.FilePath

searchFile fileName [] = return (False, "")
searchFile fileName (searchPath:rest) = do
                          { let path = searchPath </> fileName
                          ; fileExists <- doesFileExist path
                          ; if fileExists then (return (True, path)) else (searchFile fileName rest)
                          }

matchFileName pattern fileName =  case (runParser (patternToParser pattern) () "" fileName) of
                                        Left  _ -> False
                                        Right _ -> True

patternToParser :: String -> Parsec String () ()
patternToParser "" = eof
patternToParser ('*':cs) = let p = try (patternToParser cs) <|> (anyChar >> p) in p
patternToParser ('?':cs)   = noneOf "." >> patternToParser cs
patternToParser (c:cs)   = charCI c >> patternToParser cs
